<template>
    <div class="relative my-2">
        <input type="search" v-model="term" class="w-full h-10 pl-5 pr-10 rounded-md shadow-sm dark:shadow-light-sm text-gray-700 dark:text-gray-300 dark:bg-gray-700 focus:outline-none focus:shadow-outline" @input="change" />
        <div class="absolute right-0 top-0 mt-3 mr-4">
            <feather class="h-4 text-red-800 dark:text-red-300" type="x" v-show="term != ''" @click="clear" />
            <feather class="h-4 text-purple-800 dark:text-purple-200" type="search" @click="change" />
        </div>
    </div>
</template>

<style scoped>
input[type="search"]::-webkit-search-cancel-button {
  -webkit-appearance: none;
}
</style>

<script>
export default {
    props: {
        type: {
            type: String,
            required: true,
        },
        parent: {
            type: [Number, String],
            default: null,
        },
    },
    data() {
        return {
            term: "",
            cancelToken: null,
            results: [],
        }
    },
    methods: {
        change(){
            if(this.cancelToken !== null){
                this.cancelToken.cancel();
                this.cancelToken = null;
            }

            if(this.term.length > 0) {
                this.$emit('searching',true);
                // Add data for context
                const data = {};
                if(this.parent !== null){
                    data.parent = this.parent;
                }
                window.axios.post('/' + this.type + '/search/' + encodeURIComponent(this.term),data,{
                    cancelToken: this.cancelToken,
                    responseType: 'json',
                }).then(response => {
                    this.results = response.data;
                    this.$emit("searched",this.results);
                });
            } else {
                this.$emit('searching',false);
            }
        },
        clear(){
            this.term = '';
            this.change();
        }
    }
}
</script>